<?php

if (! class_exists('icsCalDisplay')) {
	class icsCalDisplay {
		var $cellWidth = '15%';
		var $cellHeight = '50px';
		
		function initCalendar($options) {
			$cellStyle = ' style="width:'.$this->cellWidth.'; height:'.$this->cellHeight.'; "';
			//$calContent .= _r($calEvents);

			$calContent = '<script type="text/javascript">
				jQuery(document).ready(function() { 
					';
					$urlString = '';
					foreach($options as $k=>$o) {
						$urlString .= '&amp;options['.$k.']='.urlencode($o);
					}
					
			$calContent .= '				jQuery("a.ics-nav-button").click(function() {
						jQuery.get("' . ICSCALENDAR_URLPATH . 'ajax-load.php?showMonth="+jQuery(this).attr("month")+"'.$urlString.'", function(data) {
							jQuery("#ics-calendar-uid > div").unbind();
							jQuery().unbind("mousemove");
							jQuery("#ics-calendar-uid").html(data);
						});
					});
				});';

			$calContent .= '</script>';
			$calContent .= '<div class="ics-calendar-header"><small><a class="ics-nav-button" id="ics-prev-button" href="javascript:void(0);">&laquo; Prev Month</a></small> ' . 
							'<div id="ics-calendar-header-text"></div> <small><a class="ics-nav-button" id="ics-next-button" href="javascript:void(0);">Next Month &raquo;</a></small></div>';
			$calContent .= '<div id="ics-calendar-uid" class="ics-calendar-holder">';
			$calContent .= icsCalDisplay::showCalendar($options);
			$calContent .= '</div>';

			return $calContent;
			
		}
		function showCalendar($options, $selected_date=NULL){
			if($selected_date==NULL) {
				$today = getdate();
			} else {
				$today = getdate(strtotime($selected_date));
			}
			
			$calArray = icsCalDisplay::getCalendarArray($today);
			
			$events = ICalEvents::get_events($options['ics_file'], $calArray[0], $calArray[count($calArray)-1], NULL);

			foreach($events as $event) {
				$calEvents[date('Y-n-j',$event['StartTime'])][] = $event;
			}
			
			$calContent = '<table class="ics-calendar-table" cellspacing="1" cellpadding="0" width="100%">';
			$calContent .= '<tr class="ics-calendar-days">'."\n";
			$calContent .= '<td>Sun</td><td>Mon</td><td>Tue</td><td>Wed</td><td>Thur</td>';
			$calContent .= '<td>Fri</td><td>Sat</td></tr>'."\n";
			
			
			// Display the first calendar row with correct positioning
			
			//Get how many complete weeks are in the actual month
			$fullWeeks = floor(count($calArray)/7);
			$x = 0;
			for ($i=0;$i<6;$i++){
				$calContent .= '<tr>';
				for ($j=0;$j<7;$j++){
					$currDate = getdate($calArray[$x]); $x++; #increase to the next item in the array.

					$calContent .= "<td>";
					//$calContent .= '<div id="ics-cell-'.$currDate['mon'].'-'.$currDate['mday'].'" class="ics-calendar-cell">';
					$calContent .= '<div class="';
						if($currDate['mon']==$today['mon']) $calContent .= 'date-holder'; else $calContent .= 'old-date-holder'; ##Current selected month, or outside the month.
						if($currDate['mday']==date('j',time()) && $currDate['year']==date('Y',time()) && $currDate['mon']==date('n',time())) $calContent .= ' ics-calendar-today'; #select the actual day.
						$calContent .= '">';
					$eventsKey = $currDate['year'].'-'.$currDate['mon'].'-'.$currDate['mday'];

					if(isset($calEvents) && array_key_exists($eventsKey,$calEvents)) {
						if(count($calEvents[$eventsKey])>2) {
							### MORE button if there are too many events
							$calContent .= '<a class="ics-more-button" href="javascript:void(0);" tag="ics-cell-'.$currDate['mon'].'-'.$currDate['mday'].'">&laquo; more</a>';
							### Get events and place them in an enlarged box.
							$calContent .= '<div id="ics-cell-'.$currDate['mon'].'-'.$currDate['mday'].'" class="ics-calendar-more-box">';
							$calContent .= '<div style="width:100%; text-align:right; "><span style="float:left; "><small><a href="javascript:void(0);" onclick="jQuery(\'#ics-cell-'.$currDate['mon'].'-'.$currDate['mday'].'\').hide()">&laquo; close</a></small></span> <b>'.$currDate['mday'].'</b></div>';
							foreach($calEvents[$eventsKey] as $event) {
								$eventUID = 'ics_'.md5($event['UID']);
								$calContent .= '<div class="ics-calendar-event" icstag="'.$eventUID.'">';
								$calContent .= $event['Summary'];
								$calContent .= '</div>';
							}
							$calContent .= '</div>';
						}						
						$calContent .= '<b>'.$currDate['mday'].'</b></div>';
						
						foreach($calEvents[$eventsKey] as $event) {
							$eventUID = 'ics_'.md5($event['UID']);
							$calContent .= '<div class="ics-calendar-event-box" id="'.$eventUID.'">';
							$calContent .= 'Event: <b>'.$event['Summary'].'</b><br />';
							
							if (ICalEvents::is_all_day($event['StartTime'], $event['EndTime']) || (isset($options['hide_time']) && $options['hide_time']=='true'))
								 $formated_date = (date($options['date_format'], $event['StartTime']));
							else 
								 $formated_date = (ICalEvents::format_date_range($event['StartTime'], $event['EndTime'], $event['Untimed'], $options['date_format'], $options['time_format']));
							$calContent .= 'When: ' . $formated_date . '<br />';
							
							if($event['Description']!='') $calContent .= 'Description: ' . $event['Description'];
							
							$calContent .= '</div>';
						}
						
						for($f=0; $f<2; $f++) {
								$eventUID = 'ics_'.md5($calEvents[$eventsKey][$f]['UID']);
								$calContent .= '<div class="ics-calendar-event" icstag="'.$eventUID.'">';
								$calContent .= $calEvents[$eventsKey][$f]['Summary'];
								$calContent .= '</div>';
						}
					} elseif($x <= count($calArray)) $calContent .= $currDate['mday'] . '</div>';
						else $calContent .= '</div>';
					//$calContent .= '</div>';
					$calContent .= "</td>"."\n";
				}
				$calContent .= '</tr>'."\n";
			}
						
			$calContent .= '</table>';
			$calContent .= '<script type="text/javascript">
								jQuery("#ics-prev-button").attr("month","'.date('Y-m-d',mktime(0,0,0,$today['mon']-1,1,$today['year'])).'");
								jQuery("#ics-next-button").attr("month","'.date('Y-m-d',mktime(0,0,0,$today['mon']+1,1,$today['year'])).'");
								jQuery("#ics-calendar-header-text").html("' . $today['month'] . ' ' . $today['year'] .'");
								jQuery().mousemove(function(e){
									jQuery(".ics-calendar-event-box").css("top",e.pageY + 5);
									jQuery(".ics-calendar-event-box").css("left",e.pageX + 5);
								});
								jQuery("a.ics-more-button").click(function() { jQuery(".ics-calendar-more-box").hide(); jQuery("#"+jQuery(this).attr("tag")).show(); });
								//jQuery(".ics-calendar-more-box").mouseout(function() { jQuery(this).hide(); });
								jQuery("div.ics-calendar-event").hover(
									function () {
										jQuery("#" + jQuery(this).attr("icstag")).show();
									}, 
									function () {
										jQuery("#" + jQuery(this).attr("icstag")).hide();
									}
								);
							</script>';
			$calContent .= '';
			
			return $calContent;
		}
		
		function eventBoxArray($array, $options, $uid) {
			$aEvents = array();
			foreach($array as $event) {
				$eventUID = 'ics_'.md5($event['UID'].time());
				$eventContent = '<div class="ics-calendar-event-box" id="'.$eventUID.$uid.'">';
				$eventContent .= 'Event: <b>'.$event['Summary'].'</b><br />';
				
				if (ICalEvents::is_all_day($event['StartTime'], $event['EndTime']) || (isset($options['hide_time']) && $options['hide_time']=='true'))
					 $formated_date = (date($options['date_format'], $event['StartTime']));
				else 
					 $formated_date = (ICalEvents::format_date_range($event['StartTime'], $event['EndTime'], $event['Untimed'], $options['date_format'], $options['time_format']));
				$eventContent .= 'When: ' . $formated_date . '<br />';
				
				if($event['Description']!='') $calContent .= 'Description: ' . $event['Description'];
				
				$eventContent .= '</div>';
				$eventContent .= '<div class="ics-calendar-event" icstag="'.$eventUID.$uid.'">';
				$eventContent .= $event['Summary'];
				$eventContent .= '</div>';
				$aEvents[] = $eventContent;
			}
			return $aEvents;
		}
		### FUNCTION THAT RETURNS ALL DAYS THAT WILL APPEAR ON A CALENDAR
		### This includes previous and next months days as well.
		function getCalendarArray($today) {
			$calEvents = array();
			$buildDay = 1;
			
			$firstDayUnix = mktime(0,0,0,$today['mon'],1,$today['year']);
			$firstDay = getdate($firstDayUnix);
			$lastDayUnix = mktime(0,0,0,$today['mon']+1,0,$today['year']);
			$lastDay  = getdate($lastDayUnix);

			$calendarArray = array();
			
			for($x=$firstDay['wday']-1;$x>=0;$x--) {
				array_push($calendarArray, (mktime(0,0,0,$today['mon'],-$x,$today['year'])));
			}
			for($x=$firstDay['wday'];$x<=6;$x++) {
				array_push($calendarArray, (mktime(0,0,0,$today['mon'],$buildDay,$today['year'])));
				$buildDay++;
			}
			$fullWeeks = floor(($lastDay['mday']-$buildDay)/7);
			for ($i=0;$i<$fullWeeks;$i++){
				for ($j=0;$j<7;$j++){
					array_push($calendarArray, (mktime(0,0,0,$today['mon'],$buildDay,$today['year'])));
					$buildDay++;
				}
			}
			if ($buildDay < $lastDay['mday']){
				for ($i=0; $i<7;$i++){
					if ($actday <= $lastDay['mday']){
						array_push($calendarArray, (mktime(0,0,0,$today['mon'],$buildDay,$today['year'])));
					} else {
						array_push($calendarArray, (mktime(0,0,0,$today['mon'],$buildDay,$today['year'])));
					}
					$buildDay++;					
				}
			}
			return $calendarArray;
		}
	}
}

?>
